﻿Imports System.Net
Imports System.Net.Sockets
Imports System.IO
Public Class file_tcp
    Public Sub New(ByVal f As mainform)
        _frm = f
    End Sub
    Private _frm As mainform  'need instance of mainform to give invoke a handle
#Region "receive files"
    Public Shared file_receive() As Byte 'store for received file
    Public Shared dfile_receive() As Byte 'store for  decripted received file
    Public Shared filereceive As String = ""
    Public Sub select_folder()
        If filereceive = "" _
          Or mainform.cancel_receive.Enabled Then Exit Sub 'no file to save or busy
        Dim words = filereceive.Split("#")
        Dim dlg As New FolderBrowserDialog
        dlg.Description = "Select the folder to store the file  " & words(0)
        If dlg.ShowDialog = DialogResult.OK Then
            My.Computer.FileSystem.WriteAllBytes(dlg.SelectedPath & "\" & words(0) _
                                    , dfile_receive, True)
        End If
    End Sub
    Private Shared r_c As Boolean  'cancel receive operation
    Public Shared WriteOnly Property receive_cancel() As Boolean
        Set(ByVal value As Boolean)
            r_c = value  'cancel recieve when true
        End Set
    End Property
    Public Sub receive_file()
        Dim rx As New System.Threading.Thread(AddressOf accept)
        rx.IsBackground = True
        rx.Start()
    End Sub
    Private Sub accept()
        Dim wordsp = filereceive.Split("#") 'the tcp listen port sent by remote
        r_c = False
        Dim cancel As String = ""
        Dim Listen As New TcpListener(IPAddress.Parse(ftp_access.iplocal), wordsp(2))
        Listen.Start()
        Dim Client As TcpClient = Listen.AcceptTcpClient() 'blocks until receive
        Dim Stream = Client.GetStream()
        Listen.Stop() 'we have connection stop listen
        _frm.Invoke(New recvdelegate(AddressOf startmessage), "Receiving " & filereceive & " from remote site")
        Try
            Dim words = filereceive.Split("#")
            Dim recbytes As Integer = 0
            file_receive = New [Byte](words(1) - 1) {}
            Dim ten_display = 0, no_show = 0  'display every 10 seconds
            Dim groupsectionbytes As Integer = 0 'total in 10 seconds
            Do Until recbytes = words(1)  'length of file sent by remote site
                Dim sectionbytes = 0
                System.Threading.Thread.Sleep(250) 'catchment time
                If Stream.DataAvailable Then
                    sectionbytes = Stream.Read(file_receive, recbytes, _
                         file_receive.Length - recbytes) 'get whats available
                    recbytes = recbytes + sectionbytes
                    no_show = 0  'we have got data this second
                Else  'data no longer being sent
                    no_show = no_show + 1  'missed data this second
                    If no_show > 119 Then  '30 seconds without data we must have 
                        Client.Close()  'lost connection so terminate all
                        Stream.Close()
                        cancel = "but" & vbNewLine & "Transfer stopped before all data received"
                    End If
                End If
                ten_display = ten_display + 1
                groupsectionbytes = groupsectionbytes + sectionbytes
                If ten_display = 39 Then  'only display every 10 seconds
                    Dim recmsg = "Downloading " & filereceive & vbNewLine & _
                    "Received " & recbytes & " bytes..number of bytes left = " & _
                    words(1) - recbytes & vbNewLine & groupsectionbytes / 10 & " bytes per second"
                    _frm.Invoke(New recvdelegate(AddressOf recvmessage), recmsg)
                    ten_display = 0 'reset counter
                    groupsectionbytes = 0 'reset bytes count
                End If
                If r_c Then  'receive cancel selected
                    Client.Close()  '   terminate all
                    Stream.Close()
                    cancel = "but" & vbNewLine & "Transfer cancelled before completion"
                    System.Threading.Thread.CurrentThread.Abort() 'only need once
                End If
            Loop
        Catch ex As Exception 'connection severed by client
            Client.Close()  '   terminate all
            Stream.Close()
            _frm.Invoke(New recvdelegate(AddressOf cancelmessage), "File transfere terminated by sender/receiver or connection failure" & vbNewLine & ex.ToString)
            System.Threading.Thread.CurrentThread.Abort() 'only need once
        Finally
            _frm.Invoke(New recvdelegate(AddressOf endrecvmessage), _
                                     "The file received " & cancel)
        End Try
        Client.Close()  '   terminate all
        Stream.Close()  '   when a receive successful
        _frm.Invoke(New recvdelegate(AddressOf endrecvmessage), _
                          "The file received " & cancel)
        System.Threading.Thread.CurrentThread.Abort() 'only need once
    End Sub
    Delegate Sub recvdelegate(ByVal recmsg As String)
    Private Sub startmessage(ByVal recmsg As String)
        _frm.receiveTextBox.Text = recmsg
        _frm.cancel_receive.Enabled = True
    End Sub
    Private Sub cancelmessage(ByVal recmsg As String)
        _frm.receiveTextBox.Text = recmsg
        _frm.cancel_receive.Enabled = False
    End Sub
    Private Sub recvmessage(ByVal recmsg As String)
        _frm.receiveTextBox.Text = recmsg
    End Sub
    Private Sub endrecvmessage(ByVal recmsg As String)
        _frm.receiveTextBox.Text = recmsg  'show complete
        _frm.cancel_receive.Enabled = False       
        Try  'show if an image
            Dim cr As New encript_decript  'encript and decript web details
            dfile_receive = cr.decript_byte(file_receive)
            Dim ms As New System.IO.MemoryStream(dfile_receive)
            _frm.PictureBoxreceive.Image = Image.FromStream(ms)
            ms.Close()  'dont need now
        Catch ex As Exception
            _frm.PictureBoxreceive.Image = My.Resources.filepicture
        End Try
    End Sub
#End Region
#Region "send files"
    Public Shared file_data() As Byte 'store for the file to be sent
    Public Shared filesend As String = "" 'store for send file name and length
    Public Sub select_file()
        Dim dlg As New OpenFileDialog
        dlg.Title = "Select a file to send to the remote site"
        If dlg.ShowDialog = DialogResult.OK Then
            file_data = My.Computer.FileSystem.ReadAllBytes(dlg.FileName)
            mainform.receiveTextBox.Text = dlg.FileName
            filesend = System.IO.Path.GetFileName(dlg.FileName) _
             & "#" & file_data.Length.ToString 'file name and length
            Try
                mainform.PictureBoxsend.Image = Image.FromFile(dlg.FileName)
            Catch ex As Exception
                mainform.PictureBoxsend.Image = My.Resources.filepicture
            End Try
            mainform.Send_file.Enabled = True  'can now send file
        End If
    End Sub
    Private Shared s_c As Boolean  'cancel send operation
    Public Shared WriteOnly Property send_cancel() As Boolean
        Set(ByVal value As Boolean)
            s_c = value  'cancel send when true
        End Set
    End Property
    Public Sub send_file()
        Dim tx As New System.Threading.Thread(AddressOf Tsend_file)
        _frm.receiveTextBox.Text = "File " & filesend & " bytes upload starting"
        tx.IsBackground = True
        tx.Start()
        _frm.Send_file.Enabled = False
        _frm.Cancel_Send.Enabled = True
    End Sub
    Private Sub Tsend_file()
        s_c = False
        Dim this_port = tcp_port()
        Dim cr As New encript_decript  'encript and decript web details
        Dim dfile_data = cr.encript_byte(file_data)
        Dim dwords() = filesend.Split("#")  'the encripted file may have more bytes
        Dim dfilesend = dwords(0) & "#" & dfile_data.Length
        text_udp.s_t(Convert.ToChar(&H25C4).ToString & dfilesend & "#" & this_port) 'send file data to remote
        System.Threading.Thread.Sleep(5000)  'give it plenty of time to receive the file info
        Try  'to see if server is available
            Dim words() As String
            words = ftp_access.remote_ports.Split("@") 'rid of udp and ip
            Dim client As New TcpClient
            client.Connect(IPAddress.Parse(words(0)), this_port)
            Dim Stream = client.GetStream() ' Retrieve the network stream.
            Dim count = 0, countnext = 0, size = 29200 'the size of chuncks to send
            Do
                Dim sw As Stopwatch = Stopwatch.StartNew()
                If dfile_data.Length < size Then size = dfile_data.Length
                countnext = count + size
                If countnext > dfile_data.Length Then size = size - countnext + dfile_data.Length
                Stream.Write(dfile_data, count, size)
                If countnext > dfile_data.Length Then Exit Do
                count = countnext
                If s_c Then
                    Stream.Close()
                    client.Close()
                    System.Threading.Thread.CurrentThread.Abort()  'finish with this file
                End If
                'System.Threading.Thread.Sleep(1000) 'simulate net speed
                _frm.Invoke(New senddelegate(AddressOf sendingmessage), "Transfering " _
                  & filesend & vbNewLine & "Uploaded " & count _
                  & " bytes..number of bytes left = " & dfile_data.Length - count _
                  & vbNewLine & CInt(size * 1000 / (sw.ElapsedMilliseconds + 1)) & " bytes per second")
            Loop
            _frm.Invoke(New senddelegate(AddressOf completemessage), "")
            Stream.Close()
            client.Close()
        Catch ex As Exception
            _frm.Invoke(New senddelegate(AddressOf errormessage), ex.ToString)
        End Try
        System.Threading.Thread.CurrentThread.Abort()  'finish with this file send
    End Sub
    Private Function tcp_port() As String
        Dim rg As New Random
        Dim words() As String
        words = ftp_access.remote_ports.Split("@")
        tcp_port = rg.Next(4000, 9999)
        Do   'not same as udp
            Try
                If tcp_port <> words(2).Substring(3) Then Exit Do
            Catch ex As Exception
                _frm.Invoke(New senddelegate(AddressOf errormessage), ex.ToString)
                System.Threading.Thread.CurrentThread.Abort() 'ports not ready
            End Try
        Loop
    End Function
    Delegate Sub senddelegate(ByVal msg As String)
    Private Sub errormessage(ByVal msg As String)
        _frm.receiveTextBox.Text = "Cant send file. Cancelled by sender/receiver or connection failure" & vbNewLine & msg
        _frm.Send_file.Enabled = True
        _frm.Cancel_Send.Enabled = False
    End Sub
    Private Sub completemessage(ByVal msg As String)
        _frm.receiveTextBox.Text = "File upload complete"
        _frm.Send_file.Enabled = True
        _frm.Cancel_Send.Enabled = False
    End Sub
    Private Sub sendingmessage(ByVal msg As String)
        _frm.receiveTextBox.Text = msg
    End Sub
#End Region
End Class
