﻿Imports System.Net.Sockets
Imports System.Net
Imports System.IO
Public Class text_udp
    Public Sub New(ByVal f As mainform)
        _frm = f
    End Sub
    Private _frm As mainform  'need instance of mainform to give invoke a handler
    Public Shared ready_ports As Boolean = False  'is remote responding
    Private Shared sw As New Stopwatch
    Public Sub send_awake()
        sw.Start()
        s_t(Convert.ToChar(&H25B2).ToString & "Remote site can send you text as at" & vbNewLine _
            & DateTime.Now.ToString("hh:mm:ss...dd/MM/yyyy"))
    End Sub
    Public Sub reply_text(ByVal msg As String)
        s_t(Convert.ToChar(&H25BA).ToString & msg)
    End Sub
    Public Sub send_text()
        sw.Start() 'see how long before responds
        _frm.receiveTextBox.Text = "Cant raise the remote site" & vbNewLine _
                   & "May have wrong ports try update host" & vbNewLine _
                   & "You may have to wait till the remote updates"
        s_t(_frm.sendTextBox.Text)
    End Sub
    Public Shared Sub s_t(ByVal msg As String)
        Dim cr As New encript_decript  'encript and decript web details
        Try
            Dim words() As String
            words = ftp_access.remote_ports.Split("@") 'rid of udp and ip
            Dim client As New UdpClient 'remote ip and udp port
            Dim rep As New IPEndPoint(IPAddress.Parse(words(0)), words(2).Substring(3))
            Dim data = cr.encript(msg)
            client.Send(data, data.Length, rep)
            client.Close()
        Catch ex As Exception
        End Try
    End Sub
    Public Sub receive_text()
        Dim RX As New System.Threading.Thread(AddressOf remoteRX)
        RX.IsBackground = True
        RX.Start() 'listen for respose to query
    End Sub
    Private Sub remoteRX() 'blocks until data received
        Dim cr As New encript_decript  'encript and decript web details
        Dim words() As String 'get rid of udp
        words = ftp_access.session_ports.Split("@") 'get the home udp port
        Dim client As New UdpClient(CInt(words(1).Substring(3))) 'listen on this port
        Do
            Try
                Dim data() As Byte
                data = client.Receive(Nothing)
                Dim msg = cr.decript(data)
                _frm.Invoke(New messdelegate(AddressOf showmessage), msg)
            Catch ex As Exception
            End Try
        Loop
    End Sub
    Delegate Sub messdelegate(ByVal msg As String)
    Private Sub showmessage(ByVal msg As String)
        If msg.Substring(0, 1) = Convert.ToChar(&H25C4).ToString Then
            file_tcp.filereceive = msg.Substring(1)
            Dim rx As New file_tcp(mainform) 'start to listen on tcp port
            rx.receive_file()
        Else
            If msg.Substring(0, 1) = Convert.ToChar(&H25BA).ToString Or _
               msg.Substring(0, 1) = Convert.ToChar(&H25B2).ToString Then
                _frm.receiveTextBox.Text = msg 'display the sent replies
            Else : _frm.usertext_receive.Text = msg  'display the sent text
            End If

            If msg.Substring(0, 1) <> Convert.ToChar(&H25BA).ToString Then 'is a reply message
                If msg.Substring(0, 1) <> Convert.ToChar(&H25B2).ToString Then
                    reply_text("The remote site has received your text") 'send received text
                    mainform.Show()
                Else
                    reply_text("The remote site has received your wakeup text") 'send wakeup text
                End If
            Else
                ready_ports = True  'the ports must be right
                _frm.receiveTextBox.Text &= vbNewLine & " Responded in " & sw.ElapsedMilliseconds & " millisecs"
                sw.Reset()
            End If
            End If
    End Sub
End Class
