﻿Imports System.IO
Imports System.Security.Cryptography
Public Class encript_decript
    Private Rijndael As New RijndaelManaged()  'symmetric encription class
    Public Function encript(ByVal value As String) As Byte()
        Return encript_byte(System.Text.Encoding.UTF8.GetBytes(value))
    End Function  'string encription entry
    Public Function encript_byte(ByVal value As Byte()) As Byte()
        newkey() 'make key using password
        Dim Transform As ICryptoTransform = Rijndael.CreateEncryptor() 'get transform
        Dim fs As New MemoryStream()
        fs.Write(Rijndael.IV, 0, Rijndael.IV.Length) 'initialisation vector first
        Dim cs As New CryptoStream(fs, Transform, CryptoStreamMode.Write)
        Dim w As New System.IO.BinaryWriter(cs) 'write binary to crypto stream
        w.Write(value) 'send all data to binary writer
        w.Flush()
        cs.FlushFinalBlock()  'must fill last block with zeros
        Return fs.ToArray()
        w.Close()
        cs.Close()
        fs.Close()
    End Function
    Public Function decript(ByVal encoded As Byte()) As String
        Return System.Text.Encoding.UTF8.GetString(decript_byte(encoded))
    End Function
    Public Function decript_byte(ByVal encoded As Byte()) As Byte()
        newkey() 'make key using password
        Dim fs = New MemoryStream(encoded)
        Dim IV As Byte()
        ReDim IV(Rijndael.IV.Length - 1)
        fs.Read(IV, 0, IV.Length)
        Rijndael.IV = IV 'got initialisation vector from file
        Dim Transform As ICryptoTransform = Rijndael.CreateDecryptor()
        Dim cs As New CryptoStream(fs, Transform, CryptoStreamMode.Read)
        Dim w As New System.IO.BinaryReader(cs) 'reads bytes from unencripted file
        decript_byte = w.ReadBytes(fs.Length)
        w.Close()
        cs.Close()
        fs.Close()
    End Function
    Private Sub newkey()  'make new key
        Dim Password As String = Input_settings.encript_pass 'use supplied password
        Dim Salt(7) As Byte    '  use random value for the salt 
        Dim Random As New RNGCryptoServiceProvider()
        Random.GetBytes(Salt)  ' Use the password to create a key.
        Dim PDB As New PasswordDeriveBytes(Password, Salt)
        Dim Key() As Byte = PDB.CryptDeriveKey("RC2", "SHA", 128, Salt)
        Rijndael.Key = Key
    End Sub
End Class
