﻿Imports System.Net.Sockets
Imports System.Text
Imports System.Net
Imports System.IO
Public Class mainform
    Private Sub SettingsToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SettingsToolStripMenuItem.Click
        Dim s As New Input_settings
        s.update_settings(True)
        Me.Text = "Internet data transfer " & s.program & " application"
    End Sub
    Private Sub ShowFormToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ShowFormToolStripMenuItem.Click
        Me.Show()
    End Sub
    Private Sub UpdateHostToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UpdateHostToolStripMenuItem.Click
        Dim d As New ftp_access
        d.display()
    End Sub
    Private Sub sendtextbutton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles sendtextbutton.Click
        Dim t As New text_udp(Me)
        t.send_text()  ' send whats in text box
    End Sub
    Private Sub HideToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles HideToolStripMenuItem.Click
        help.Show()
    End Sub
    Private Sub Hide_form_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Hide_form.Click
        Me.Hide()
    End Sub
    Private Sub cancel_receive_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cancel_receive.Click
        file_tcp.receive_cancel = True
    End Sub
    Private Sub PictureBoxreceive_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBoxreceive.Click
        Dim tcp As New file_tcp(Me)
        tcp.select_folder()
    End Sub
    Private Sub PictureBoxsend_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBoxsend.Click
        If Cancel_Send.Enabled Then Exit Sub 'sending picture cant change
        Dim tcp As New file_tcp(Me)
        tcp.select_file()
    End Sub
    Private Sub Send_file_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Send_file.Click
        Dim tcp As New file_tcp(Me)
        tcp.send_file()
    End Sub
    Private Sub Cancel_Send_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Send.Click
        file_tcp.send_cancel = True
    End Sub
    Private Sub sendwake_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles sendwake.Tick
        Dim t As New text_udp(Me)
        t.send_awake()
        text_udp.ready_ports = False
        checkports.Enabled = True  'check in 10 seconds to see if response
    End Sub
    Private Sub checkports_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles checkports.Tick
        checkports.Enabled = False 'only once
        If text_udp.ready_ports Then Exit Sub 'already have correct ports
        Dim d As New ftp_access
        d.display()  'need to check ports again
    End Sub
    Private Sub mainform_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ftp_access.udp_ftp() 'set random udp port
        Dim tx As New text_udp(Me) 'start to listen on udp port
        tx.receive_text()
        Dim w As New Input_settings 'check settings
        If Not w.update_settings(False) Then Exit Sub ''cannot continue
        Me.Text = "Internet data transfer " & w.program & " application"
        Dim d As New ftp_access
        If d.display() Then
            tx.send_awake() 'if got remote port and ip can send awake
        End If
    End Sub
    Private Sub mainform_Shown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shown
        Me.Hide()
    End Sub
    Private Sub PictureBoxsend_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles PictureBoxsend.MouseEnter
        Label2.Text = "Select file to send"
    End Sub
    Private Sub PictureBoxsend_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles PictureBoxsend.MouseLeave
        Label2.Text = ""
    End Sub
    Private Sub PictureBoxreceive_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles PictureBoxreceive.MouseEnter
        Label3.Text = "Select folder to save file"
    End Sub
    Private Sub PictureBoxreceive_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles PictureBoxreceive.MouseLeave
        Label3.Text = ""
    End Sub
End Class
